/*     */ package compro.player;
/*     */ 
/*     */ import java.awt.Color;
/*     */ import java.awt.Font;
/*     */ import java.awt.Graphics;
/*     */ import java.awt.Image;
/*     */ import java.awt.MenuItem;
/*     */ import java.awt.PopupMenu;
/*     */ import java.awt.Rectangle;
/*     */ import java.awt.Toolkit;
/*     */ import java.awt.event.ActionEvent;
/*     */ import java.awt.event.ActionListener;
/*     */ import java.awt.event.MouseEvent;
/*     */ import java.awt.event.MouseListener;
/*     */ import java.awt.image.BufferedImage;
/*     */ import java.net.MalformedURLException;
/*     */ import java.net.URL;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import javax.imageio.ImageIO;
/*     */ import javax.swing.JApplet;
/*     */ import javax.swing.RepaintManager;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class MJPEGStreaming
/*     */   extends JApplet
/*     */   implements MouseListener
/*     */ {
/*     */   static final String version = "20111207_1";
/*     */   static final boolean enable_recording = false;
/*     */   static final boolean support_ptz = true;
/*     */   static final String video_page = "cgi-bin/push_mjpeg.cgi";
/*     */   static final String audio_page = "cgi-bin/push_audio.cgi";
/*     */   static final int timeout = 5000;
/*     */   static final int retry = 3;
/*     */   static final int jpeg_bufsiz = 100000;
/*     */   MJPEGStreaming MJS;
/*     */   String title;
/*     */   String streaming_ip;
/*     */   String http_port;
/*     */   String userpass;
/*     */   String embed_text;
/*     */   String embed_pos;
/*     */   String embed_img;
/*     */   String recording_dest;
/*     */   boolean enable_audio;
/*     */   boolean enable_watermark_text;
/*     */   boolean enable_watermark_img;
/*     */   boolean enable_ptz;
/*     */   boolean enable_fps_output;
/*     */   boolean enable_bitrate_output;
/*     */   boolean enable_debug_twoway;
/*     */   POSITION watermark_pos;
/*     */   Image watermarkImage;
/*     */   int videoWidth;
/*     */   int videoHeight;
/*     */   int width;
/*     */   int height;
/*     */   float volume;
/*     */   Image picture;
/*     */   Graphics bufferGraphics;
/*     */   Image offScreen;
/*     */   VideoThread videoThread;
/*     */   AudioThread audioThread;
/*     */   ManagerThread managerThread;
/*     */   TwoWayAudioThread twoWayAudioThread;
/*     */   boolean isTwoWayAudio;
/*     */   public String twoWaySource;
/*     */   public float twoWayVolume;
/*     */   private String supportedSource;
/*     */   
/*     */   public enum POSITION
/*     */   {
/* 111 */     UpperRight, UpperLeft, LowerRight, LowerLeft;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 140 */   double fps = 0.0D;
/* 141 */   double zoom = 1.0D;
/*     */ 
/*     */   
/* 144 */   int x1 = 0, x2 = 0, y1 = 0, y2 = 0;
/* 145 */   int px = 0; int py = 0;
/* 146 */   double z_width = 0.0D; double z_height = 0.0D;
/* 147 */   int zoom_x1 = 0; int zoom_y1 = 0;
/*     */   
/*     */   public enum MODE
/*     */   {
/* 151 */     VIEWER, MOTION, PTZ_CENTER, PTZ_CMOVE;
/*     */   }
/* 153 */   MODE Mode = MODE.VIEWER;
/*     */ 
/*     */   
/* 156 */   MotionDetection MD = null;
/*     */   
/*     */   String motionRegion;
/*     */   
/* 160 */   PTZControl PTZ = null;
/*     */   
/*     */   URL videoURL;
/*     */   
/*     */   URL auidoURL;
/*     */   String ptzURL;
/*     */   String base64streaming;
/*     */   String base64ptz;
/*     */   
/*     */   public enum CONNECT
/*     */   {
/* 171 */     CONNECTING, CONNECT, DISCONNECT;
/*     */   }
/* 173 */   CONNECT connStatus = CONNECT.CONNECTING;
/*     */   PopupMenu reconnectMenu;
/* 175 */   int videoRetry = 0;
/* 176 */   int audioRetry = 0;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void parseParameters() {
/* 183 */     this.width = (getSize()).width;
/* 184 */     this.height = (getSize()).height;
/*     */     
/* 186 */     this.videoWidth = this.width;
/* 187 */     this.videoHeight = this.height;
/* 188 */     this.x2 = this.videoWidth;
/* 189 */     this.y2 = this.videoHeight;
/*     */ 
/*     */     
/* 192 */     this.streaming_ip = getParameter("streaming_ip");
/* 193 */     this.http_port = getParameter("http_port");
/* 194 */     this.userpass = getParameter("userpass");
/* 195 */     this.base64streaming = "Basic " + this.userpass;
/* 196 */     System.out.println("base64streaming:" + this.base64streaming);
/*     */ 
/*     */     
/* 199 */     this.motionRegion = getParameter("motion_region");
/*     */ 
/*     */     
/* 202 */     this.enable_ptz = false;
/* 203 */     if (getParameter("enable_ptz") != null && 
/* 204 */       getParameter("enable_ptz").matches("YES")) {
/* 205 */       this.enable_ptz = true;
/*     */     }
/*     */ 
/*     */     
/* 209 */     this.enable_audio = false;
/* 210 */     if (getParameter("enable_audio") != null && 
/* 211 */       getParameter("enable_audio").matches("YES")) {
/* 212 */       this.enable_audio = true;
/*     */     }
/*     */ 
/*     */     
/* 216 */     this.enable_fps_output = false;
/* 217 */     this.enable_bitrate_output = false;
/* 218 */     if (getParameter("extend") != null) {
/* 219 */       if (getParameter("extend").matches("0214")) {
/* 220 */         this.enable_fps_output = true;
/* 221 */         System.out.println("Enable FPS output");
/* 222 */       } else if (getParameter("extend").matches("0215")) {
/* 223 */         this.enable_bitrate_output = true;
/* 224 */         System.out.println("Enable BITRATE output");
/* 225 */       } else if (getParameter("extend").matches("0216")) {
/* 226 */         this.enable_debug_twoway = true;
/*     */       } 
/*     */     }
/*     */ 
/*     */     
/* 231 */     this.embed_text = getParameter("embed_text");
/* 232 */     this.embed_pos = getParameter("embed_pos");
/* 233 */     this.enable_watermark_text = false;
/* 234 */     this.enable_watermark_img = false;
/* 235 */     if (this.embed_pos != null) {
/*     */       
/* 237 */       if (this.embed_text != null && !this.embed_text.equals("")) {
/* 238 */         this.enable_watermark_text = true;
/*     */       }
/*     */       
/*     */       try {
/* 242 */         BufferedImage bufferedImage = ImageIO.read(new URL("http://" + this.streaming_ip + ":" + this.http_port + "/EmbedFile/EmbedImage"));
/* 243 */         this.watermarkImage = Toolkit.getDefaultToolkit().createImage(bufferedImage.getSource());
/* 244 */         int i = this.watermarkImage.getHeight(this);
/* 245 */         int j = this.watermarkImage.getWidth(this);
/* 246 */         if (i > 0 && j > 0) {
/* 247 */           this.enable_watermark_img = true;
/* 248 */           if (i != 100 || j != 30)
/* 249 */             this.watermarkImage = this.watermarkImage.getScaledInstance(100, 30, 1); 
/*     */         } 
/* 251 */       } catch (Exception exception) {
/* 252 */         this.enable_watermark_img = false;
/*     */       } 
/*     */       
/* 255 */       if (this.enable_watermark_text || this.enable_watermark_img) {
/*     */         try {
/* 257 */           this.watermark_pos = POSITION.valueOf(this.embed_pos);
/* 258 */         } catch (Exception exception) {
/* 259 */           this.watermark_pos = POSITION.UpperLeft;
/*     */         } 
/*     */       }
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void init() {
/* 269 */     System.out.println("Version:20111207_1");
/*     */     
/* 271 */     this.MJS = this;
/* 272 */     this.recording_dest = "";
/*     */     
/* 274 */     parseParameters();
/*     */ 
/*     */     
/* 277 */     this.isTwoWayAudio = false;
/* 278 */     this.twoWaySource = "MICROPHONE";
/* 279 */     this.twoWayVolume = 50.0F;
/* 280 */     this.supportedSource = "";
/*     */ 
/*     */     
/* 283 */     this.volume = 50.0F;
/*     */ 
/*     */     
/*     */     try {
/* 287 */       this.videoURL = new URL("http://" + this.streaming_ip + ":" + this.http_port + "/" + "cgi-bin/push_mjpeg.cgi");
/* 288 */       this.auidoURL = new URL("http://" + this.streaming_ip + ":" + this.http_port + "/" + "cgi-bin/push_audio.cgi");
/* 289 */       System.out.println("videoURL:" + this.videoURL);
/* 290 */     } catch (MalformedURLException malformedURLException) {
/* 291 */       System.out.println("videoURL, auidoURL Wrong");
/*     */     } 
/*     */ 
/*     */     
/* 295 */     createReconnectMenu(this);
/* 296 */     addMouseListener(this);
/*     */ 
/*     */     
/* 299 */     setBackground(Color.white);
/* 300 */     this.offScreen = createImage(this.width, this.height);
/* 301 */     this.bufferGraphics = this.offScreen.getGraphics();
/* 302 */     RepaintManager.currentManager(this).setDoubleBufferingEnabled(true);
/*     */ 
/*     */     
/* 305 */     this.MD = new MotionDetection(this.width, this.height);
/* 306 */     if (this.motionRegion != null) {
/* 307 */       changeToMotionMode(this.motionRegion);
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 315 */     if (this.enable_ptz) {
/* 316 */       this.Mode = MODE.PTZ_CENTER;
/* 317 */       this.PTZ = new PTZControl(this.width, this.height, this.streaming_ip, Integer.parseInt(this.http_port), this.base64streaming);
/*     */     } 
/*     */     
/* 320 */     startStreaming();
/* 321 */     if (this.enable_debug_twoway)
/*     */     {
/*     */ 
/*     */ 
/*     */       
/* 326 */       startTwoWayAudio();
/*     */     }
/*     */   }
/*     */   
/*     */   public void start() {
/* 331 */     System.out.println("start event");
/*     */   }
/*     */ 
/*     */   
/*     */   public void paint(Graphics paramGraphics) {
/* 336 */     if (this.connStatus == CONNECT.CONNECTING || this.connStatus == CONNECT.DISCONNECT) {
/* 337 */       drawConnStatus(this.bufferGraphics, this.connStatus, this.width, this.height);
/*     */     }
/* 339 */     else if (this.connStatus == CONNECT.CONNECT && 
/* 340 */       this.picture != null && this.picture.getWidth(this) != -1) {
/* 341 */       if (this.picture.getWidth(this) != this.videoWidth) {
/* 342 */         this.videoWidth = this.picture.getWidth(this);
/* 343 */         this.videoHeight = this.picture.getHeight(this);
/* 344 */         onSizeChanged();
/*     */       } 
/* 346 */       this.bufferGraphics.drawImage(this.picture, 0, 0, this.width, this.height, this.x1, this.y1, this.x2, this.y2, this);
/*     */ 
/*     */       
/* 349 */       if (this.Mode == MODE.MOTION) {
/* 350 */         this.MD.draw(this.bufferGraphics);
/*     */       }
/*     */       
/* 353 */       if (this.enable_watermark_text || this.enable_watermark_img) {
/* 354 */         drawWaterMark(this.bufferGraphics, this.enable_watermark_text, this.embed_text, this.enable_watermark_img, this.watermark_pos, this.width, this.height);
/*     */       }
/*     */       
/* 357 */       if (!this.recording_dest.matches("")) {
/* 358 */         drawStatus(this.bufferGraphics, this.watermark_pos, this.width, this.height, "Recording to " + this.recording_dest);
/*     */       }
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 365 */     paramGraphics.drawImage(this.offScreen, 0, 0, this);
/*     */     
/* 367 */     if (this.width != (getSize()).width || this.height != (getSize()).height) {
/* 368 */       setSize((getSize()).width, (getSize()).height);
/*     */     }
/*     */   }
/*     */   
/*     */   private void drawStatus(Graphics paramGraphics, POSITION paramPOSITION, int paramInt1, int paramInt2, String paramString) {
/* 373 */     double d = paramInt1 / 640.0D;
/* 374 */     int i = (int)(32.0D * d);
/* 375 */     Font font = new Font("SansSerif", 1, i);
/* 376 */     this.bufferGraphics.setFont(font);
/* 377 */     this.bufferGraphics.setColor(Color.RED);
/*     */     
/* 379 */     Rectangle rectangle = getFontBounds(this.bufferGraphics, paramString, font);
/* 380 */     int j = (int)rectangle.getWidth();
/* 381 */     int k = (int)rectangle.getHeight();
/* 382 */     int m = (int)(15.0D * d);
/* 383 */     int n = k;
/*     */     
/* 385 */     if ((this.enable_watermark_text || this.enable_watermark_img) && paramPOSITION == POSITION.UpperRight) {
/* 386 */       this.bufferGraphics.drawString(paramString, m, n);
/*     */     } else {
/* 388 */       this.bufferGraphics.drawString(paramString, paramInt1 - m - j, n);
/*     */     } 
/*     */   }
/*     */   
/*     */   private void drawWaterMark(Graphics paramGraphics, boolean paramBoolean1, String paramString, boolean paramBoolean2, POSITION paramPOSITION, int paramInt1, int paramInt2) {
/* 393 */     double d1 = paramInt1 / 640.0D;
/* 394 */     double d2 = paramInt1 / 640.0D * 1.5D;
/* 395 */     int i = (int)(32.0D * d1);
/* 396 */     int j = 0, k = 0, m = 0, n = 0;
/* 397 */     int i1 = 0, i2 = 0, i3 = 0, i4 = 0;
/* 398 */     int i5 = 0, i6 = 0, i7 = 0, i8 = 0;
/*     */     
/* 400 */     Font font = new Font("SansSerif", 1, i);
/* 401 */     this.bufferGraphics.setFont(font);
/* 402 */     this.bufferGraphics.setColor(Color.BLACK);
/*     */     
/* 404 */     Rectangle rectangle = null;
/* 405 */     if (paramBoolean1) {
/* 406 */       rectangle = getFontBounds(this.bufferGraphics, paramString, font);
/* 407 */       j = (int)rectangle.getWidth();
/* 408 */       k = (int)rectangle.getHeight();
/* 409 */       m = (int)(10.0D * d2);
/* 410 */       n = k;
/*     */     } 
/*     */     
/* 413 */     if (paramBoolean2) {
/* 414 */       i1 = (int)(this.watermarkImage.getWidth(this) * d2);
/* 415 */       i2 = (int)(this.watermarkImage.getHeight(this) * d2);
/* 416 */       i3 = (int)(10.0D * d2);
/* 417 */       i4 = (int)(10.0D * d2) + n;
/*     */     } 
/*     */     
/* 420 */     if (paramPOSITION == POSITION.UpperRight) {
/* 421 */       i5 = paramInt1 - m - j;
/* 422 */       i6 = n;
/* 423 */       i7 = paramInt1 - i3 - i1;
/* 424 */       i8 = i4;
/* 425 */     } else if (paramPOSITION == POSITION.UpperLeft) {
/* 426 */       i5 = m;
/* 427 */       i6 = n;
/* 428 */       i7 = i3;
/* 429 */       i8 = i4;
/* 430 */     } else if (paramPOSITION == POSITION.LowerRight) {
/* 431 */       i5 = paramInt1 - m - j;
/* 432 */       i6 = paramInt2 - n / 2;
/* 433 */       i7 = paramInt1 - i3 - i1;
/* 434 */       i8 = paramInt2 - i4 - i2;
/* 435 */     } else if (paramPOSITION == POSITION.LowerLeft) {
/* 436 */       i5 = m;
/* 437 */       i6 = paramInt2 - n / 2;
/* 438 */       i7 = i3;
/* 439 */       i8 = paramInt2 - i4 - i2;
/*     */     } 
/*     */     
/* 442 */     if (paramBoolean1) {
/* 443 */       this.bufferGraphics.drawString(paramString, i5, i6);
/*     */     }
/* 445 */     if (paramBoolean2)
/* 446 */       this.bufferGraphics.drawImage(this.watermarkImage, i7, i8, i1 + i7, i2 + i8, 0, 0, this.watermarkImage.getWidth(this), this.watermarkImage.getHeight(this), this); 
/*     */   }
/*     */   
/*     */   private void drawConnStatus(Graphics paramGraphics, CONNECT paramCONNECT, int paramInt1, int paramInt2) {
/* 450 */     double d1 = 0.0D, d2 = 0.0D, d3 = 0.0D, d4 = 0.0D, d5 = 0.0D, d6 = 0.0D;
/* 451 */     byte b = 0;
/* 452 */     Rectangle rectangle = null;
/* 453 */     if (paramInt1 >= 320) {
/* 454 */       b = 16;
/*     */     } else {
/* 456 */       b = 10;
/* 457 */     }  Font font = new Font("SansSerif", 1, b);
/*     */     
/* 459 */     String str1 = "Connecting to " + this.streaming_ip;
/* 460 */     String str2 = "Click here to connect to";
/* 461 */     String str3 = this.streaming_ip;
/* 462 */     this.bufferGraphics.setFont(font);
/* 463 */     rectangle = getFontBounds(this.bufferGraphics, str1, font);
/* 464 */     d1 = (paramInt1 - rectangle.getWidth()) / 2.0D;
/* 465 */     d2 = (paramInt2 - rectangle.getHeight()) / 2.0D;
/*     */     
/* 467 */     rectangle = getFontBounds(this.bufferGraphics, str2, font);
/* 468 */     d3 = (paramInt1 - rectangle.getWidth()) / 2.0D;
/* 469 */     d4 = (paramInt2 - rectangle.getHeight()) / 2.0D - rectangle.getHeight() / 2.0D;
/*     */     
/* 471 */     rectangle = getFontBounds(this.bufferGraphics, str3, font);
/* 472 */     d5 = (paramInt1 - rectangle.getWidth()) / 2.0D;
/* 473 */     d6 = (paramInt2 - rectangle.getHeight()) / 2.0D + rectangle.getHeight() / 2.0D;
/*     */ 
/*     */     
/* 476 */     this.bufferGraphics.setColor(Color.DARK_GRAY);
/* 477 */     this.bufferGraphics.fillRect(0, 0, paramInt1, paramInt2);
/* 478 */     this.bufferGraphics.setColor(Color.LIGHT_GRAY);
/*     */ 
/*     */     
/* 481 */     if (paramCONNECT == CONNECT.CONNECTING) {
/* 482 */       this.bufferGraphics.drawString(str1, (int)d1, (int)d2);
/* 483 */     } else if (paramCONNECT == CONNECT.DISCONNECT) {
/* 484 */       this.bufferGraphics.drawString(str2, (int)d3, (int)d4);
/* 485 */       this.bufferGraphics.drawString(str3, (int)d5, (int)d6);
/*     */     } 
/*     */   }
/*     */   
/*     */   private Rectangle getFontBounds(Graphics paramGraphics, String paramString, Font paramFont) {
/* 490 */     return new Rectangle(paramGraphics.getFontMetrics().stringWidth(paramString), paramGraphics.getFontMetrics().getHeight());
/*     */   }
/*     */ 
/*     */   
/*     */   public void update(Graphics paramGraphics) {
/* 495 */     paint(paramGraphics);
/*     */   }
/*     */   
/*     */   public void stop() {
/* 499 */     System.out.println("stop event");
/*     */   }
/*     */   
/*     */   public void destroy() {
/* 503 */     System.out.println("destroy event");
/* 504 */     stopStreaming();
/*     */   }
/*     */   
/*     */   public void startStreaming() {
/* 508 */     this.videoRetry = 0;
/* 509 */     this.audioRetry = 0;
/* 510 */     this.managerThread = new ManagerThread(this);
/* 511 */     this.managerThread.start();
/*     */   }
/*     */   
/*     */   public void stopStreaming() {
/* 515 */     this.managerThread.terminateThread();
/*     */   }
/*     */   
/*     */   private void onSizeChanged() {
/* 519 */     zoom(this.zoom, this.zoom_x1, this.zoom_y1);
/* 520 */     if (this.Mode == MODE.MOTION) {
/* 521 */       this.MD.setSize(this.width, this.height);
/*     */     }
/* 523 */     if (this.enable_ptz) {
/* 524 */       this.PTZ.setSize(this.width, this.height);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setRecordingStatus(String paramString) {
/* 532 */     this.recording_dest = paramString;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setTwoWayAudioSource(String paramString) {
/* 539 */     if (!paramString.equals("MICROPHONE") && !paramString.equals("LINE_IN")) {
/* 540 */       System.out.println("setTwoWayAudioSource error argument");
/*     */       return;
/*     */     } 
/* 543 */     if (!this.twoWaySource.equals(paramString)) {
/* 544 */       if (this.isTwoWayAudio && 
/* 545 */         this.twoWayAudioThread != null && 
/* 546 */         this.twoWayAudioThread.isAlive()) {
/* 547 */         this.twoWayAudioThread.terminateThread();
/*     */       }
/*     */ 
/*     */       
/* 551 */       this.twoWaySource = paramString;
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setTwoWayAudioVolume(String paramString) {
/* 559 */     float f = Float.parseFloat(paramString);
/* 560 */     if (f < 0.0F || f > 100.0F) {
/* 561 */       System.out.println("setTwoWayAudioVolume error argument");
/*     */       return;
/*     */     } 
/* 564 */     this.twoWayVolume = f;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getSupportedSource() {
/* 577 */     if (this.supportedSource.equals("") || this.supportedSource.equals("##")) {
/* 578 */       Boolean bool = Boolean.valueOf(false);
/* 579 */       if (this.isTwoWayAudio && this.twoWayAudioThread != null && this.twoWayAudioThread.isAlive()) {
/* 580 */         bool = Boolean.valueOf(true);
/*     */       } else {
/* 582 */         AccessController.doPrivileged(new PrivilegedAction() {
/*     */               public Object run() {
/*     */                 try {
/* 585 */                   MJPEGStreaming.this.twoWayAudioThread = new TwoWayAudioThread(MJPEGStreaming.this.streaming_ip, Integer.parseInt(MJPEGStreaming.this.http_port), MJPEGStreaming.this.MJS);
/* 586 */                 } catch (Exception exception) {
/* 587 */                   MJPEGStreaming.this.supportedSource = "##";
/* 588 */                   return MJPEGStreaming.this.supportedSource;
/*     */                 } 
/* 590 */                 return null;
/*     */               }
/*     */             });
/*     */       } 
/* 594 */       this.supportedSource += "#";
/* 595 */       if (this.twoWayAudioThread.isMicSupported().booleanValue())
/* 596 */         this.supportedSource += "MICROPHONE#"; 
/* 597 */       if (this.twoWayAudioThread.isLineInSupported().booleanValue())
/* 598 */         this.supportedSource += "LINE_IN#"; 
/* 599 */       if (!bool.booleanValue())
/* 600 */         this.twoWayAudioThread = null; 
/*     */     } 
/* 602 */     return this.supportedSource;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void startTwoWayAudio() {
/* 610 */     if (!this.isTwoWayAudio) {
/* 611 */       this.isTwoWayAudio = true;
/* 612 */       if (this.twoWayAudioThread != null && 
/* 613 */         this.twoWayAudioThread.isAlive()) {
/* 614 */         this.twoWayAudioThread.terminateThread();
/*     */       }
/*     */       
/* 617 */       AccessController.doPrivileged(new PrivilegedAction() {
/*     */             public Object run() {
/*     */               try {
/* 620 */                 MJPEGStreaming.this.twoWayAudioThread = new TwoWayAudioThread(MJPEGStreaming.this.streaming_ip, Integer.parseInt(MJPEGStreaming.this.http_port), MJPEGStreaming.this.MJS);
/*     */                 
/* 622 */                 MJPEGStreaming.this.twoWayAudioThread.start();
/*     */ 
/*     */               
/*     */               }
/* 626 */               catch (Exception exception) {
/* 627 */                 exception.printStackTrace();
/*     */               } 
/* 629 */               return null;
/*     */             }
/*     */           });
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void stopTwoWayAudio() {
/* 639 */     if (this.isTwoWayAudio) {
/* 640 */       if (this.twoWayAudioThread != null) {
/* 641 */         if (this.twoWayAudioThread.isAlive()) {
/* 642 */           this.twoWayAudioThread.delayStop();
/*     */         }
/*     */       } else {
/*     */         
/* 646 */         this.isTwoWayAudio = false;
/*     */       } 
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   public int getTwowayStatus() {
/* 654 */     if (this.isTwoWayAudio) {
/* 655 */       return 1;
/*     */     }
/* 657 */     return 0;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setVolume(String paramString) {
/* 665 */     float f = Float.parseFloat(paramString);
/* 666 */     if (f < 0.0F || f > 100.0F) {
/* 667 */       System.out.println("setVolume error argument");
/*     */       return;
/*     */     } 
/* 670 */     this.volume = f;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getWidth() {
/* 678 */     return (getSize()).width;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getHeight() {
/* 685 */     return (getSize()).height;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void callSetSize() {
/* 692 */     setSize((getSize()).width, (getSize()).height);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setSize(int paramInt1, int paramInt2) {
/* 700 */     if (paramInt1 > 0 && paramInt2 > 0) {
/* 701 */       this.width = paramInt1;
/* 702 */       this.height = paramInt2;
/* 703 */       super.setSize(paramInt1, paramInt2);
/* 704 */       validate();
/*     */       
/* 706 */       onSizeChanged();
/* 707 */       this.offScreen = createImage(paramInt1, paramInt2);
/* 708 */       this.bufferGraphics = this.offScreen.getGraphics();
/*     */     } else {
/* 710 */       System.out.println("setSize error argument");
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setSizeWithResolution() {
/* 718 */     setSize(this.videoWidth, this.videoHeight);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getVideoWidth() {
/* 725 */     return this.videoWidth;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getVideoHeight() {
/* 732 */     return this.videoHeight;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void changeMode(String paramString) {
/* 739 */     if (paramString != "MOTION") {
/* 740 */       this.Mode = MODE.valueOf(paramString);
/* 741 */       System.out.println(this.Mode);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void changeToMotionMode(String paramString) {
/* 749 */     this.Mode = MODE.MOTION;
/* 750 */     this.MD.setSelectedRegionsInBit(paramString);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public double getFPS() {
/* 757 */     return this.fps;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void zoom(double paramDouble, int paramInt1, int paramInt2) {
/* 764 */     this.zoom_x1 = paramInt1;
/* 765 */     this.zoom_y1 = paramInt2;
/*     */     
/* 767 */     if (paramDouble != -1.0D) {
/* 768 */       this.zoom = paramDouble;
/* 769 */       this.z_width = this.videoWidth / this.zoom;
/* 770 */       this.z_height = this.videoHeight / this.zoom;
/*     */     } 
/*     */     
/* 773 */     this.x1 = (int)(paramInt1 * this.videoWidth / this.width);
/* 774 */     this.y1 = (int)(paramInt2 * this.videoHeight / this.height);
/* 775 */     this.x2 = this.x1 + (int)this.z_width;
/* 776 */     this.y2 = this.y1 + (int)this.z_height;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getMDRegions() {
/* 783 */     return this.MD.getSelectedRegionsInBit();
/*     */   }
/*     */   
/*     */   private void createReconnectMenu(MJPEGStreaming paramMJPEGStreaming) {
/* 787 */     this.reconnectMenu = new PopupMenu();
/* 788 */     MenuItem menuItem = new MenuItem("Reconnect");
/* 789 */     menuItem.addActionListener(this.menuListener);
/* 790 */     this.reconnectMenu.add(menuItem);
/* 791 */     paramMJPEGStreaming.add(this.reconnectMenu);
/*     */   }
/*     */   
/* 794 */   ActionListener menuListener = new ActionListener() {
/*     */       public void actionPerformed(ActionEvent param1ActionEvent) {
/* 796 */         MJPEGStreaming.this.connStatus = MJPEGStreaming.CONNECT.CONNECTING;
/* 797 */         MJPEGStreaming.this.repaint();
/* 798 */         MJPEGStreaming.this.startStreaming();
/*     */       }
/*     */     };
/*     */ 
/*     */   
/*     */   public void mousePressed(MouseEvent paramMouseEvent) {
/* 804 */     if ((paramMouseEvent.getModifiers() & 0x4) == 4 && (
/* 805 */       this.connStatus == CONNECT.DISCONNECT || this.connStatus == CONNECT.CONNECTING)) {
/* 806 */       this.reconnectMenu.show(this, paramMouseEvent.getX(), paramMouseEvent.getY());
/*     */     }
/*     */     
/* 809 */     if (this.connStatus == CONNECT.DISCONNECT) {
/* 810 */       this.connStatus = CONNECT.CONNECTING;
/* 811 */       repaint();
/* 812 */       startStreaming();
/* 813 */     } else if (this.connStatus == CONNECT.CONNECT) {
/* 814 */       if (this.Mode == MODE.MOTION) {
/*     */         
/* 816 */         this.MD.updateRegion(paramMouseEvent.getX(), paramMouseEvent.getY());
/*     */ 
/*     */       
/*     */       }
/* 820 */       else if (this.Mode == MODE.PTZ_CMOVE) {
/* 821 */         if (this.enable_ptz) {
/* 822 */           this.PTZ.ContinuousMove(paramMouseEvent.getX(), paramMouseEvent.getY());
/*     */         }
/* 824 */       } else if (this.Mode == MODE.PTZ_CENTER && 
/* 825 */         this.enable_ptz) {
/* 826 */         this.px = paramMouseEvent.getX();
/* 827 */         this.py = paramMouseEvent.getY();
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseReleased(MouseEvent paramMouseEvent) {
/* 835 */     if (this.connStatus == CONNECT.CONNECT && 
/* 836 */       this.enable_ptz)
/* 837 */       if (this.Mode == MODE.PTZ_CMOVE) {
/* 838 */         this.PTZ.ContinuousMoveStop();
/* 839 */       } else if (this.Mode == MODE.PTZ_CENTER) {
/* 840 */         this.PTZ.CenterMove(this.px, this.py);
/*     */       }  
/*     */   }
/*     */   
/*     */   public void mouseClicked(MouseEvent paramMouseEvent) {}
/*     */   
/*     */   public void mouseEntered(MouseEvent paramMouseEvent) {}
/*     */   
/*     */   public void mouseExited(MouseEvent paramMouseEvent) {}
/*     */ }


/* Location:              /home/ericu/zyxel_ipc_camera_pwn/tmp/ipc2605_snapshot/web/html/MJPEGStreaming.jar!/compro/player/MJPEGStreaming.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       1.1.3
 */