/*     */ package compro.player;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.net.URL;
/*     */ import javax.sound.sampled.AudioFormat;
/*     */ import javax.sound.sampled.AudioInputStream;
/*     */ import javax.sound.sampled.AudioSystem;
/*     */ import javax.sound.sampled.DataLine;
/*     */ import javax.sound.sampled.FloatControl;
/*     */ import javax.sound.sampled.LineUnavailableException;
/*     */ import javax.sound.sampled.SourceDataLine;
/*     */ import javax.sound.sampled.UnsupportedAudioFileException;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AudioThread
/*     */   extends MyThread
/*     */ {
/*     */   private SourceDataLine line;
/*     */   private AudioInputStream sourceAudioStream;
/*     */   private AudioInputStream encodedAudioStream;
/*     */   public InputStream audioIn;
/*     */   private AudioFormat sourceFormat;
/*     */   private AudioFormat encodedFormat;
/*     */   private DataLine.Info info;
/*     */   private FloatControl volumeControl;
/*     */   private float volumeRange;
/*     */   private float currentVolume;
/*     */   static final float minimumVolume = -40.0F;
/*  31 */   private URL audioURL = null;
/*  32 */   private String base64auth = null;
/*     */   private MJPEGStreaming MJS;
/*     */   
/*     */   public AudioThread(InputStream paramInputStream) {
/*  36 */     this.audioIn = paramInputStream;
/*     */   }
/*     */   public AudioThread(URL paramURL, String paramString) {
/*  39 */     this.audioURL = paramURL;
/*  40 */     this.base64auth = paramString;
/*     */   }
/*     */   public AudioThread(URL paramURL, String paramString, MJPEGStreaming paramMJPEGStreaming) {
/*  43 */     this.audioURL = paramURL;
/*  44 */     this.base64auth = paramString;
/*  45 */     this.MJS = paramMJPEGStreaming;
/*  46 */     this.currentVolume = 0.0F;
/*     */   }
/*     */ 
/*     */   
/*     */   private void adjustVolume(float paramFloat) {
/*  51 */     if (this.currentVolume != paramFloat) {
/*  52 */       this.currentVolume = paramFloat;
/*  53 */       if (paramFloat < 0.0F) {
/*  54 */         this.volumeControl.setValue(-80.0F);
/*  55 */       } else if (paramFloat > 100.0F) {
/*  56 */         this.volumeControl.setValue(this.volumeRange + -40.0F);
/*     */       } else {
/*  58 */         this.volumeControl.setValue(paramFloat * this.volumeRange / 100.0F + -40.0F);
/*     */       } 
/*     */     } 
/*     */   }
/*     */   private synchronized void startPlaying() throws IOException, LineUnavailableException, UnsupportedAudioFileException {
/*  63 */     byte[] arrayOfByte = new byte[2048];
/*     */ 
/*     */     
/*  66 */     this.sourceFormat = new AudioFormat(AudioFormat.Encoding.ULAW, 8000.0F, 8, 1, 1, 8000.0F, false);
/*  67 */     this.sourceAudioStream = new AudioInputStream(this.audioIn, this.sourceFormat, Long.MAX_VALUE);
/*     */ 
/*     */     
/*  70 */     this.encodedFormat = new AudioFormat(8000.0F, 16, 1, true, false);
/*  71 */     this.encodedAudioStream = AudioSystem.getAudioInputStream(this.encodedFormat, this.sourceAudioStream);
/*  72 */     this.info = new DataLine.Info(SourceDataLine.class, this.encodedFormat);
/*     */ 
/*     */ 
/*     */     
/*  76 */     while (!isTerminated()) {
/*  77 */       this.line = (SourceDataLine)AudioSystem.getLine(this.info);
/*  78 */       this.line.open();
/*  79 */       this.line.start();
/*     */ 
/*     */       
/*  82 */       this.volumeControl = (FloatControl)this.line.getControl(FloatControl.Type.MASTER_GAIN);
/*  83 */       this.volumeRange = this.volumeControl.getMaximum() - -40.0F;
/*     */       
/*  85 */       int i = 0;
/*  86 */       while (i != -1 && !isTerminated()) {
/*  87 */         adjustVolume(this.MJS.volume);
/*  88 */         i = this.encodedAudioStream.read(arrayOfByte, 0, arrayOfByte.length);
/*  89 */         if (i >= 0) {
/*  90 */           this.line.write(arrayOfByte, 0, i);
/*     */         } else {
/*  92 */           throw new IOException();
/*     */         } 
/*     */         
/*  95 */         if (this.MJS.audioRetry != -1) {
/*  96 */           this.MJS.audioRetry = -1;
/*  97 */           this.MJS.connStatus = MJPEGStreaming.CONNECT.CONNECT;
/*     */         } 
/*     */       } 
/*     */     } 
/*     */     
/* 102 */     this.line.drain();
/* 103 */     this.line.close();
/*     */   }
/*     */   public void run() {
/* 106 */     setTerminated(false);
/* 107 */     boolean bool = false;
/*     */     
/*     */     try {
/* 110 */       bool = connect(this.audioURL, this.base64auth);
/* 111 */     } catch (IOException iOException) {
/* 112 */       System.out.println("Cannot connect to audioURL");
/* 113 */       this.MJS.audioRetry++;
/*     */     } 
/*     */     
/*     */     try {
/* 117 */       if (bool) {
/* 118 */         this.audioIn = this.dataIn;
/* 119 */         startPlaying();
/*     */       } 
/* 121 */     } catch (LineUnavailableException lineUnavailableException) {
/* 122 */       System.out.println("AudioThread LineUnavailableException");
/* 123 */       this.MJS.audioRetry++;
/* 124 */       if (this.MJS.audioRetry >= 3) {
/* 125 */         this.MJS.enable_audio = false;
/*     */       }
/* 127 */     } catch (IOException iOException) {
/* 128 */       System.out.println("AudioThread read data error");
/* 129 */       this.MJS.audioRetry++;
/* 130 */     } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
/* 131 */       System.out.println("AudioThread UnsupportedAudioFileException");
/* 132 */       this.MJS.audioRetry++;
/*     */     } finally {
/* 134 */       closeDataIn();
/*     */     } 
/*     */   }
/*     */ }


/* Location:              /home/ericu/zyxel_ipc_camera_pwn/tmp/ipc2605_snapshot/web/html/MJPEGStreaming.jar!/compro/player/AudioThread.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       1.1.3
 */