/*     */ package compro.player;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import java.net.Socket;
/*     */ import javax.sound.sampled.AudioFormat;
/*     */ import javax.sound.sampled.AudioInputStream;
/*     */ import javax.sound.sampled.AudioSystem;
/*     */ import javax.sound.sampled.BooleanControl;
/*     */ import javax.sound.sampled.CompoundControl;
/*     */ import javax.sound.sampled.Control;
/*     */ import javax.sound.sampled.DataLine;
/*     */ import javax.sound.sampled.FloatControl;
/*     */ import javax.sound.sampled.Line;
/*     */ import javax.sound.sampled.LineUnavailableException;
/*     */ import javax.sound.sampled.Mixer;
/*     */ import javax.sound.sampled.Port;
/*     */ import javax.sound.sampled.TargetDataLine;
/*     */ 
/*     */ 
/*     */ public class TwoWayAudioThread
/*     */   extends MyThread
/*     */ {
/*     */   private static final boolean isContinuousTwoway = false;
/*     */   private static final int bufsiz = 4096;
/*     */   private TargetDataLine targetDataLine;
/*     */   private AudioInputStream sourceAudioStream;
/*     */   private AudioInputStream encodedAudioStream;
/*     */   private Boolean isLineInSupported;
/*     */   private Boolean isMicSupported;
/*     */   private AudioFormat sourceFormat;
/*     */   private AudioFormat encodedFormat;
/*     */   private DataLine.Info info;
/*  34 */   private byte[] buf = null;
/*     */ 
/*     */   
/*  37 */   private String IP = null;
/*  38 */   private int Port = 0;
/*     */   
/*     */   private String http_header;
/*     */   
/*     */   private Socket socket;
/*     */   
/*     */   private OutputStream outputStream;
/*     */   private Boolean delayStop;
/*     */   private MJPEGStreaming MJS;
/*     */   
/*     */   public TwoWayAudioThread(String paramString, int paramInt, MJPEGStreaming paramMJPEGStreaming) {
/*  49 */     this.IP = paramString;
/*  50 */     this.Port = paramInt;
/*  51 */     this.outputStream = null;
/*  52 */     this.socket = null;
/*  53 */     this.http_header = "POST /cgi-bin/fifo.cgi HTTP/1.1\r\nConnection: Keep-Alive\r\nContent-Length: 409600\r\nHost: " + this.IP + ":" + this.Port + "\r\n" + "\r\n";
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  59 */     this.delayStop = Boolean.valueOf(false);
/*     */ 
/*     */     
/*  62 */     this.sourceFormat = new AudioFormat(8000.0F, 16, 1, true, false);
/*  63 */     this.encodedFormat = new AudioFormat(AudioFormat.Encoding.ULAW, 8000.0F, 8, 1, 1, 8000.0F, false);
/*  64 */     this.info = new DataLine.Info(TargetDataLine.class, this.sourceFormat);
/*     */     
/*  66 */     this.targetDataLine = null;
/*  67 */     this.buf = new byte[4096];
/*     */ 
/*     */ 
/*     */     
/*  71 */     this.MJS = paramMJPEGStreaming;
/*     */   }
/*     */   
/*     */   private void checkSupportedInput() {
/*  75 */     this.isLineInSupported = Boolean.valueOf(false);
/*  76 */     this.isMicSupported = Boolean.valueOf(false);
/*  77 */     Mixer.Info[] arrayOfInfo = AudioSystem.getMixerInfo();
/*  78 */     for (Mixer.Info info : arrayOfInfo) {
/*  79 */       Mixer mixer = AudioSystem.getMixer(info);
/*  80 */       if (mixer.isLineSupported(Port.Info.MICROPHONE)) {
/*  81 */         this.isMicSupported = Boolean.valueOf(true);
/*  82 */       } else if (mixer.isLineSupported(Port.Info.LINE_IN)) {
/*  83 */         this.isLineInSupported = Boolean.valueOf(true);
/*     */       } 
/*     */     } 
/*     */   }
/*     */   
/*     */   public Boolean isMicSupported() {
/*  89 */     return this.isMicSupported;
/*     */   }
/*     */   
/*     */   public Boolean isLineInSupported() {
/*  93 */     return this.isLineInSupported;
/*     */   }
/*     */   
/*     */   private void print() throws LineUnavailableException {
/*  97 */     System.out.println("==================");
/*  98 */     Mixer.Info[] arrayOfInfo = AudioSystem.getMixerInfo();
/*  99 */     byte b = 0;
/* 100 */     for (Mixer.Info info : arrayOfInfo) {
/*     */       
/* 102 */       System.out.println(b);
/* 103 */       System.out.println("getSourceLineInfo");
/* 104 */       Mixer mixer = AudioSystem.getMixer(info);
/*     */       
/* 106 */       if (mixer.isLineSupported(Port.Info.MICROPHONE)) {
/* 107 */         System.out.println("MIC!!");
/* 108 */       } else if (mixer.isLineSupported(Port.Info.LINE_IN)) {
/* 109 */         System.out.println("LINE_IN!!");
/*     */       } 
/* 111 */       Line.Info[] arrayOfInfo1 = mixer.getSourceLineInfo();
/* 112 */       for (Line.Info info1 : arrayOfInfo1) {
/* 113 */         System.out.println(info.getName() + "---" + info1);
/* 114 */         Line line = mixer.getLine(info1);
/* 115 */         System.out.println("\t-----" + line);
/*     */       } 
/*     */       
/* 118 */       System.out.println("getTargetLineInfo");
/* 119 */       arrayOfInfo1 = mixer.getTargetLineInfo();
/* 120 */       for (Line.Info info1 : arrayOfInfo1) {
/* 121 */         System.out.println(mixer + "---" + info1);
/* 122 */         Line line = mixer.getLine(info1);
/* 123 */         System.out.println("\t-----" + line);
/*     */       } 
/*     */       try {
/* 126 */         this.targetDataLine = AudioSystem.getTargetDataLine(this.sourceFormat, info);
/* 127 */         if (b == 6)
/*     */           break; 
/* 129 */         System.out.println("success:" + b++);
/* 130 */       } catch (Exception exception) {
/* 131 */         System.out.println("failed:" + b++);
/*     */       } 
/*     */     } 
/* 134 */     System.out.println("==================");
/*     */   }
/*     */ 
/*     */   
/*     */   private void initialDevice() throws LineUnavailableException {
/* 139 */     this.targetDataLine = (TargetDataLine)AudioSystem.getLine(this.info);
/* 140 */     this.targetDataLine.open(this.sourceFormat);
/*     */     
/* 142 */     this.targetDataLine.start();
/*     */     
/* 144 */     this.sourceAudioStream = new AudioInputStream(this.targetDataLine);
/* 145 */     this.encodedAudioStream = AudioSystem.getAudioInputStream(this.encodedFormat, this.sourceAudioStream);
/*     */   }
/*     */   
/*     */   private void adjustVolumeAndSource() throws LineUnavailableException {
/* 149 */     System.out.println("Source:" + this.MJS.twoWaySource);
/* 150 */     Port.Info info = new Port.Info(Port.class, this.MJS.twoWaySource, true);
/*     */ 
/*     */     
/* 153 */     Port port = (Port)AudioSystem.getLine(info);
/* 154 */     setRecControlValue(port);
/*     */   }
/*     */   
/*     */   private void setRecControlValue(Port paramPort) throws LineUnavailableException {
/* 158 */     paramPort.open();
/* 159 */     Control[] arrayOfControl = paramPort.getControls();
/* 160 */     for (byte b = 0; b < arrayOfControl.length; b++) {
/* 161 */       if (arrayOfControl[b] instanceof CompoundControl) {
/* 162 */         Control[] arrayOfControl1 = ((CompoundControl)arrayOfControl[b]).getMemberControls();
/* 163 */         for (byte b1 = 0; b1 < arrayOfControl1.length; b1++) {
/* 164 */           setCtrl(arrayOfControl1[b1]);
/*     */         }
/*     */       } else {
/*     */         
/* 168 */         setCtrl(arrayOfControl[b]);
/*     */       } 
/* 170 */     }  paramPort.close();
/*     */   }
/*     */   
/*     */   private void setCtrl(Control paramControl) {
/* 174 */     System.out.println(paramControl.getType().toString());
/* 175 */     if (paramControl.getType().toString().equals("Select")) {
/* 176 */       System.out.println("a");
/* 177 */       ((BooleanControl)paramControl).setValue(true);
/*     */     } 
/* 179 */     if (paramControl.getType().toString().equals("Volume")) {
/* 180 */       System.out.println("b");
/* 181 */       FloatControl floatControl = (FloatControl)paramControl;
/* 182 */       float f = floatControl.getMinimum() + (floatControl.getMaximum() - floatControl.getMinimum()) * this.MJS.twoWayVolume / 100.0F;
/* 183 */       floatControl.setValue(f);
/*     */     } 
/*     */   }
/*     */   
/*     */   public void delayStop() {
/* 188 */     this.delayStop = Boolean.valueOf(true);
/*     */   }
/*     */   
/*     */   private void stopRecording() {
/* 192 */     System.out.println("stopTwoWayAudio"); 
/* 193 */     try { this.outputStream.close(); } catch (IOException iOException) {} 
/* 194 */     try { this.socket.close(); } catch (IOException iOException) {} 
/* 195 */     try { this.encodedAudioStream.close(); } catch (IOException iOException) {} 
/* 196 */     try { this.sourceAudioStream.close(); } catch (IOException iOException) {}
/* 197 */     this.targetDataLine.stop();
/* 198 */     this.targetDataLine.close();
/* 199 */     this.MJS.isTwoWayAudio = false;
/*     */   }
/*     */   
/*     */   private void startRecording() throws IOException {
/* 203 */     System.out.println("startTwoWayAudio");
/* 204 */     this.socket = new Socket(this.IP, this.Port);
/* 205 */     this.outputStream = this.socket.getOutputStream();
/* 206 */     this.outputStream.write(this.http_header.getBytes());
/* 207 */     this.outputStream.flush();
/* 208 */     long l1 = System.currentTimeMillis();
/* 209 */     long l2 = 0L;
/* 210 */     long l3 = 0L;
/* 211 */     int i = 0;
/* 212 */     int j = 0;
/* 213 */     while (!isTerminated()) {
/* 214 */       j = this.encodedAudioStream.read(this.buf, 0, this.buf.length);
/*     */       
/* 216 */       i += j;
/* 217 */       if (j > 0) {
/* 218 */         this.outputStream.write(this.buf);
/* 219 */         this.outputStream.flush();
/* 220 */       } else if (j < 0) {
/* 221 */         setTerminated(true);
/*     */       } 
/*     */       
/* 224 */       l2 = System.currentTimeMillis() - l1;
/* 225 */       if (l2 >= 30000L || i > 401408) {
/* 226 */         this.outputStream.close();
/* 227 */         this.socket.close();
/* 228 */         setTerminated(true);
/*     */       } 
/*     */       
/* 231 */       if (this.delayStop.booleanValue()) {
/* 232 */         if (l3 == 0L) {
/* 233 */           l3 = System.currentTimeMillis(); continue;
/*     */         } 
/* 235 */         if (System.currentTimeMillis() - l3 >= 2000L) {
/* 236 */           setTerminated(true);
/*     */         }
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   public void run() {
/* 245 */     setTerminated(false);
/*     */ 
/*     */     
/*     */     try {
/* 249 */       initialDevice();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 259 */       startRecording();
/*     */     }
/* 261 */     catch (LineUnavailableException lineUnavailableException) {
/* 262 */       System.out.println("TwoWayAudioThread LineUnavailableException");
/* 263 */     } catch (IOException iOException) {
/* 264 */       System.out.println("startRecording IOException");
/*     */     } finally {
/* 266 */       stopRecording();
/*     */     } 
/*     */   }
/*     */ }


/* Location:              /home/ericu/zyxel_ipc_camera_pwn/tmp/ipc2605_snapshot/web/html/MJPEGStreaming.jar!/compro/player/TwoWayAudioThread.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       1.1.3
 */