/*     */ package compro.player;
/*     */ 
/*     */ import java.awt.MediaTracker;
/*     */ import java.awt.Toolkit;
/*     */ import java.io.BufferedInputStream;
/*     */ import java.io.IOException;
/*     */ import java.net.URL;
/*     */ 
/*     */ public class VideoThread
/*     */   extends MyThread
/*     */ {
/*     */   private BufferedInputStream videoIn;
/*  13 */   private myUtilityIO utilityIO = new myUtilityIO();
/*     */   
/*     */   private MJPEGStreaming MJS;
/*     */   
/*     */   private myUtilityIO.jpeg_object jpeg_obj;
/*     */   MediaTracker tracker;
/*  19 */   private long startTime = 0L;
/*  20 */   private long processTime = 0L;
/*  21 */   private int count = 0;
/*  22 */   private int acc_bytes = 0;
/*     */   
/*  24 */   private URL videoURL = null;
/*  25 */   private String base64auth = null;
/*     */ 
/*     */   
/*     */   public VideoThread(URL paramURL, String paramString, MJPEGStreaming paramMJPEGStreaming) {
/*  29 */     this.videoURL = paramURL;
/*  30 */     this.base64auth = paramString;
/*  31 */     this.MJS = paramMJPEGStreaming;
/*  32 */     this.tracker = new MediaTracker(this.MJS);
/*     */   }
/*     */ 
/*     */   
/*     */   private synchronized void startPlaying() throws NumberFormatException, InterruptedException, IOException {
/*  37 */     this.startTime = System.currentTimeMillis();
/*     */     
/*  39 */     while (!isTerminated()) {
/*  40 */       this.jpeg_obj = this.utilityIO.readImage(this.videoIn);
/*     */       
/*  42 */       if (this.MJS.videoRetry != -1) {
/*  43 */         this.MJS.videoRetry = -1;
/*  44 */         this.MJS.connStatus = MJPEGStreaming.CONNECT.CONNECT;
/*     */       } 
/*  46 */       if (this.jpeg_obj.size > 0) {
/*     */         
/*  48 */         this.MJS.picture = Toolkit.getDefaultToolkit().createImage(this.jpeg_obj.jpeg_data, 0, this.jpeg_obj.size);
/*     */         
/*  50 */         this.tracker.addImage(this.MJS.picture, 0);
/*  51 */         this.tracker.waitForAll(100L);
/*  52 */         this.MJS.repaint();
/*  53 */         this.tracker.removeImage(this.MJS.picture, 0);
/*     */         
/*  55 */         if (this.MJS.enable_fps_output) {
/*  56 */           this.count++;
/*     */         }
/*  58 */         if (this.MJS.enable_bitrate_output) {
/*     */           
/*  60 */           this.count++;
/*  61 */           this.acc_bytes += this.jpeg_obj.size;
/*     */         } 
/*     */       } 
/*  64 */       sleep(20L);
/*     */       
/*  66 */       if (this.MJS.enable_fps_output) {
/*  67 */         this.processTime = System.currentTimeMillis() - this.startTime;
/*  68 */         if (this.processTime > 1000L) {
/*  69 */           this.MJS.fps = this.count / this.processTime / 1000.0D;
/*  70 */           System.out.println("fps:" + this.MJS.fps);
/*  71 */           this.count = 0;
/*  72 */           this.startTime = System.currentTimeMillis();
/*     */         } 
/*     */       } 
/*     */       
/*  76 */       if (this.MJS.enable_bitrate_output) {
/*  77 */         this.processTime = System.currentTimeMillis() - this.startTime;
/*  78 */         if (this.processTime > 10000L) {
/*  79 */           this.MJS.fps = this.count / this.processTime / 1000.0D;
/*  80 */           int i = this.acc_bytes / 1024 / (int)(this.processTime / 1000.0D);
/*  81 */           System.out.println("Bitrate:" + i + "kbps" + " fps:" + this.MJS.fps);
/*  82 */           this.acc_bytes = 0;
/*  83 */           this.count = 0;
/*  84 */           this.startTime = System.currentTimeMillis();
/*     */         } 
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */   
/*     */   public void run() {
/*  92 */     setTerminated(false);
/*  93 */     boolean bool = false;
/*     */     
/*     */     try {
/*  96 */       bool = connect(this.videoURL, this.base64auth);
/*  97 */     } catch (IOException iOException) {
/*  98 */       System.out.println("Cannot connect to videoURL");
/*  99 */       this.MJS.videoRetry++;
/*     */     } 
/*     */     
/*     */     try {
/* 103 */       if (bool) {
/* 104 */         this.videoIn = this.dataIn;
/* 105 */         startPlaying();
/*     */       } 
/* 107 */     } catch (InterruptedException interruptedException) {
/* 108 */       System.out.println("VideoThread InterruptedException");
/* 109 */       this.MJS.videoRetry++;
/* 110 */     } catch (IOException iOException) {
/* 111 */       System.out.println("VideoThread read data error");
/* 112 */       this.MJS.videoRetry++;
/* 113 */     } catch (NumberFormatException numberFormatException) {
/* 114 */       System.out.println("VideoThread parse ContentLength error");
/* 115 */       this.MJS.videoRetry++;
/*     */     } finally {
/* 117 */       closeDataIn();
/*     */     } 
/*     */   }
/*     */ }


/* Location:              /home/ericu/zyxel_ipc_camera_pwn/tmp/ipc2605_snapshot/web/html/MJPEGStreaming.jar!/compro/player/VideoThread.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       1.1.3
 */